## S01: vecteurs numeriques et caracteres

c(1, 3, 4, 10, 2231)

c("dna", "prot", "rna")

## S02: vecteurs logiques

vec_l <- c(TRUE, FALSE, TRUE, FALSE)
vec_l
class(vec_l)

TRUE
FALSE

c(1, 2, "3")
c(1, 2, TRUE, FALSE)
c(1, 2, TRUE, "FALSE")

w <- c(42, 76, 55, 121, 78)
length(w)

w[c(1, 3)]

w[c(TRUE, FALSE, TRUE, FALSE, FALSE)]

## extraire les elements de w plus petits que 60
w[w < 60]

## 1. 
sel <- w < 60
w[sel]

length(sel)
length(w)

w[w > 100]

## recycling
w[c(TRUE, FALSE)]
w

w[c(TRUE, FALSE, TRUE, FALSE, TRUE)]

1:10
1:5

(1:2) + (1:2)
(1:10) + (1:5)

## <=  >= == 
length(sel) == length(w)

## ! negation

!TRUE
!FALSE

## elements inferieurs ou egaux a 100
w[w <= 100]
w[!w > 100]

## ou: | 
## et: &

w < 60
w > 100

w[w < 60 | w > 100]

w > 60
w < 100
w[w > 60 & w < 100]

vec_vide <- w[w < 60 & w > 100]
length(vec_vide)
class(vec_vide)

## en partant des du vecteur w, creez w2 qui contient 
## les elements strictement compris entre 75 et 100
w <- c(42, 76, 55, 121, 78)

sel <- w > 75 & w < 100
which(sel)
w[sel]
w[which(sel)]

w2 <- w[w > 75 & w < 100]
w2


x <- c("dna", "prot", "rna")

x[x == "dna" | x == "rna" | x == "meta" | x == "autre"]

x[x %in% c("dna", "rna", "meta", "autre")]


## names / noms

w
names(w)

names(w) <- c("a", "b", "c", "d", "e")

names(w)

w[c(1, 3)]

w[c("a", "c")]

names(w) <- LETTERS[1:5]
w

pi
letters
LETTERS
month.abb
month.name

names(w) <- c("a12", "z3", "c1", "a44", "a00")

## subsetting:
## - index
## - noms
## - logiques

## donnees manquantes - missing data
names(w) <- c("a", "b", "c", "d", "e")

w[c("a", "c", "z")]

NA

length(c(NA, NA, NA))

class(c("A", "a", NA))

x <- c(1, 4, 6, 3, NA, 6)
x
length(x)
class(x)

mean(x)
mean(x, na.rm = FALSE)
mean(x, na.rm = TRUE)

sum(x, na.rm = TRUE)


is.na(x)
which(is.na(x))

!is.na(x)
which(!is.na(x))

mean(x[!is.na(x)])
mean(x, na.rm = TRUE)

na.omit(x)

x[complete.cases(x)]


heights <- c(63, 69, 60, 65, NA, 68, 61, 70, 61, 59, 64, 69, 63, 63, NA, 72, 65, 64, 70, 63, 65)
length(heights)

## Using this vector of heights in inches, 
## create a new vector with the NAs removed.

any(is.na(heights))
sum(is.na(heights))
which(is.na(heights))
table(is.na(heights))

na.omit(heights)
h2 <- heights[!is.na(heights)]
h2

## Use the function median() to calculate the median of
## the heights vector.

median(heights, na.rm = TRUE)
median(h2)

## Use R to figure out how many people in the set are taller 
## than 67 inches.

heights > 67 ## ! NA
sum(heights > 67)
sum(heights > 67, na.rm = TRUE)
sum(na.omit(heights) > 67)
sum(h2 > 67)

## generation de vecteurs

numeric(10)

rep(1, 10)
rep(NA, 10)
rep(c(1, 4, 10), 10)
rep(c(1, 4, 10), each = 10)
rep(letters[1:5], 3)

seq(1, 10, 2)
seq(1, 10, 3)
seq(from = 1, to = 10, by = 3)
seq(1, 10, length.out = 4)
seq(1, 10, length.out = 3)
1:10
seq(1, 10, 1)

paste("a", "1", sep = "")
names(w) <- paste(letters[1:5], 1:5, sep = "")
w

sample(10)
sample(1:10)
sample(letters)
sample(10, 5)
sample(1:10, 20, replace = TRUE)

rnorm(10)
rnorm(10, mean = 0, sd = 1)
rnorm(100000)
rnorm(100000, 10, 2)
mean(rnorm(10000, mean = 0, sd = 1))
mean(rnorm(10000, mean = 10, sd = 2))


## Create two vectors x and y containing the numbers 1 to 10 and 
## 10 to 1 respectively. You can use the seq or : functions rather 
## than constructing them by hand.

x <- seq(1, 10)
x
y <- seq(10, 1)
y

## Check their type. Depending how they were created, 
## they can be integers or doubles.
class(x)
class(y)

## Take the sum (see the sum() function) of each vector 
## and verify they are identical.
sum(x)
sum(y)

sum(x) == sum(y)

identical(sum(x), sum(y))

## Sum vectors element-wise, and verify that all 
## results are identical.

length(x) == length(y)

x
y
z <- x + y
z
length(z)

length(unique(z)) == 1

## Swap the value or x and y.
x
y

x_old <- x
x <- y
y <- x_old

rm(x_old)

rev(x)
rev(y)
