## download data
download.file(url = "https://ndownloader.figshare.com/files/2292169",
              destfile = "data/portal_data_joined.csv")

## error! no data2 directory
download.file(url = "https://ndownloader.figshare.com/files/2292169",
             destfile = "data2/portal_data_joined.csv")

## import csv file into R and create
## new variable called survey
survey <- read.csv("data/portal_data_joined.csv")

## a data.frame
class(survey)

## explore the data.frame
ncol(survey)
names(survey)
nrow(survey)
dim(survey)

str(survey)

head(survey)
tail(survey)

View(survey)

## subsetting [

survey[10, 3]
survey[1, 1]
survey[29561, 12]

survey[, 1]
str(survey[, 1])

y <- survey[, 4]
length(y)
nrow(survey)
table(y)

survey[1, ]
class(survey[1, ])
dim(survey[1, ])

survey[1:10, c(2, 3, 4, 13)]

head(survey)
survey[1:6, ]

survey[1, -c(1, 13)]
dim(survey[-1, -c(1, 13)])

head(survey)
survey[1:6, ]
survey[-(7:34786), ]

survey[, 4]

survey[, "year"] ## vecteur
survey$year      ## vecteur
survey[["year"]] ## vecteur
survey["year"]   ## data.frame
dim(survey["year"])

## Exercice

survey_200 <- survey[200, ]
survey_200

nrow(survey)

survey[34786, ]
tail(survey)

survey_last <- survey[nrow(survey), ]
survey_last

nrow(survey)
nrow(survey)/2

survey_middle <- survey[nrow(survey)/2, ]
survey_middle

head(survey)
survey[-(7:34786), ]
survey[-( 7:nrow(survey) ), ]


names(survey)
colnames(survey)
rownames(survey)


survey$weight ## num: length == nrow(survey)
is.na(survey$weight) ## log: length == nrow(survey)
sel_w <- is.na(survey$weight)

table(sel_w)

length(sel_w) == nrow(survey)

table(sel_w)

nrow(survey[sel_w, ])
nrow(survey[!sel_w, ])

View(survey[sel_w, ])
View(survey[!sel_w, ])

survey_with_weigth <- survey[!sel_w, ]
head(survey_with_weigth)
dim(survey_with_weigth)

table(is.na(survey_with_weigth$weight))

survey_noNA <- na.omit(survey)
dim(survey_noNA)

## import: 
## - read.csv()
## - read.csv2() 
## - read.delim()
?read.table
## export
write.csv(survey_noNA, file = "data/survey_noNA.csv")

## save() and load()
## saveRDS() and readRDS()

saveRDS(survey_noNA, file = "data/survey_noNA.rds")
rm(survey_noNA)
x <- readRDS("data/survey_noNA.rds")



