## remplacement
x <- sample(LETTERS[1:10])
x

x[1] <- "!"
x[2:3] <- c("@", "#")
x

dfr <- data.frame(
  x = 1:3, 
  y = LETTERS[1:3],
  z = c(TRUE, TRUE, FALSE))
dfr

dfr[1, 1] <- 10
dfr

dfr[1:2, "y"] <- letters[1:2]
dfr

dfr$a <- 3:1
dfr

dfr$b <- NA
dfr

## packages
## charger
library("rWSBIM1207")
library(tidyverse)

## installer
## CRAN
install.packages("tidyverse")
## other
BiocManager::install("UCLouvain-CBIO/rWSBIM1207")



filter ## namespace::stats 
library(tidyverse)
filter ## namespace::dplyr

stats::filter
dplyr::filter

## dplyr
## utils::read.csv
surveys <- read_csv("~/Teaching/WSBIM1207/data/portal_data_joined.csv")

## select - cols
select(surveys, 
       plot_id, 
       species_id)

select(surveys, 
       -plot_id, 
       -species_id)

## filter - rows
filter(surveys,
       year == 1995)

filter(surveys,
       year == 1995, 
       sex == "M")

## select AND filter
s2 <- select(surveys, 
             plot_id,
             year, 
             species_id)
filter(s2, year == 1995)

s2 <- filter(surveys,
             year == 1995)
select(s2, 
       plot_id,
       species_id,
       year)

surveys %>% 
  select(plot_id, 
         species_id, 
         year) %>% 
  filter(year == 1995)

surveys %>% 
  filter(year == 1995) %>% 
  select(plot_id,
         species_id,
         year)
  
## mutate

surveys %>% 
  mutate(weight_kg = weight / 1000) %>% 
  select(species_id, 
         weight, 
         weight_kg)

surveys %>% 
  filter(!is.na(weight)) %>% 
  mutate(weight_kg = weight / 1000) %>% 
  select(species_id, 
         weight, 
         weight_kg)

surveys %>% 
  filter(!is.na(weight)) %>% 
  mutate(weight_kg = weight / 1000,
         weight2 = weight * 2) %>% 
  select(species_id, 
         weight, 
         weight_kg,
         weight2)


dfr <- data.frame(
  x = 1:3, 
  y = LETTERS[1:3],
  z = c(TRUE, TRUE, FALSE))
dfr

dfr %>% 
  mutate(x2 = x * 2)

x2 <- dfr$x * 2
dfr$x2 <- x2
dfr

dfr <- data.frame(
  x = c(1, NA, 2), 
  y = LETTERS[1:3],
  z = c(TRUE, TRUE, FALSE))
dfr

!is.na(dfr$x)

dfr %>% 
  filter(!is.na(x))

## afficher le species_id et plot_id
## des observations capturees en 1995

## ERROR
surveys %>% 
  select(plot_id, species_id) %>% 
  filter(year == 1995)

surveys %>% 
  select(plot_id, species_id, year) %>% 
  filter(year == 1995)

surveys %>% 
  filter(year == 1995) %>% 
  select(plot_id, species_id)

surveys %>% 
  filter(year == 1995) %>% 
  select(plot_id, species_id) %>% 
  mutate(id2 = plot_id * 2) %>% 
  filter(id2 > 5)

s1995 <- filter(surveys, year == 1995)
s1995_id <- select(s1995, plot_id, species_id)
s1995_id <- mutate(s1995_id, id2 = plot_id * 2)
filter(s1995_id, id2 > 5)
  
## group_by and summarise

surveys %>% 
  group_by(sex) %>% 
  summarise(mean_weight = mean(weight, na.rm = TRUE))

surveys %>% 
  filter(!is.na(weight)) %>% 
  group_by(sex) %>% 
  summarise(mean_weight = mean(weight))

surveys %>% 
  group_by(species_id, sex) %>%   
  summarise(mean_weight = mean(weight, na.rm = TRUE))

surveys %>% 
  filter(!is.na(sex)) %>% 
  group_by(sex, species_id) %>% 
  summarise(mean_weight = mean(weight, 
                               na.rm = TRUE)) %>% 
  arrange(species_id)

surveys %>% 
  filter(!is.na(sex)) %>% 
  group_by(sex, species_id) %>% 
  summarise(mean_weight = mean(weight, 
                               na.rm = TRUE)) %>% 
  arrange(desc(species_id))

surveys %>% 
  filter(!is.na(sex)) %>% 
  filter(!is.na(weight)) %>% 
  group_by(sex, species_id) %>% 
  summarise(min_w = min(weight),
            max_w = max(weight),
            mean_w = mean(weight)) %>% 
  arrange(species_id)

w_by_ss <- 
  surveys %>% 
  filter(!is.na(sex)) %>% 
  filter(!is.na(weight)) %>% 
  group_by(sex, species_id) %>% 
  summarise(min_w = min(weight),
            max_w = max(weight),
            mean_w = mean(weight),
            count = n()) %>% 
  arrange(species_id) 

View(w_by_ss)

## reshaping data
surveys_gs <- 
  surveys %>% 
  filter(!is.na(weight)) %>% 
  group_by(genus, plot_id) %>% 
  summarise(mean_weight = mean(weight))

surveys_gs

surveys_wide <- surveys_gs %>% 
  pivot_wider(names_from = genus, 
              values_from = mean_weight)

surveys_long <- surveys_wide %>% 
  pivot_longer(names_to = "genus",
               values_to = "mean_weight",
               -plot_id)

surveys_long


