library(tidyverse)
library(rWSBIM1207)
library(lubridate)

## visualiser l'évolution des cas covid en BE et IT

## charger les données
x <- read_csv(covid19_cases.csv())


## vous familiariser avec les données
names(x)
x$Country_Region
filter(x, Country_Region %in% c("Belgium", "Italy"))

xl <- x %>% 
  pivot_longer(names_to = "date",
               values_to = "cases",
               -(1:4)) %>% 
  mutate(date = mdy(date))

## au lieu d'exclure les col 1:4, il est
## possible d'inclure 5: la fin ou en les
## nommant "1/22/20":"6/13/20".

x %>% 
  pivot_longer(names_to = "date",
               values_to = "cases",
               "1/22/20":"6/13/20")

## visualiser l'évolution des cas covid en BE et IT

xl %>% 
  filter(Country_Region %in% 
           c("Belgium", "Italy")) %>% 
  ggplot(aes(x = date,
             y = cases,
             colour = Country_Region)) +
  geom_line()


xl %>% 
  filter(Country_Region == "Belgium" | 
         Country_Region == "Italy")
