download.file(url="https://ndownloader.figshare.com/files/2292169",
              destfile = "data/portal_data_joined.csv")
survey <- read.csv("data/portal_data_joined.csv")

dim(survey)
ncol(survey)
nrow(survey)
head(survey)
tail(survey)
str(survey)
class(survey)



# subsetting []

survey[10 , 3 ]
survey[1,1]
survey[29561, 12]

survey[, 1]
str(survey[,1])

y <- survey[, 4]
length(y)
nrow(survey)

table(y)

survey[1,]
class(survey[1,])
dim(survey[1,])

survey[1:10, c(2,3,4,13)]

head(survey)
survey[1:6,]

# prendre tout sauf les colonnes 1 et 13
survey[1, -c(1, 13)]
dim(survey[1, -c(1, 13)])

head(survey)
survey[1:6,]


# pour le subsetting, on peut aussi use le nom des lignes ou colonnes
# ça ns permet d'extraire la colonne qu'on veut
survey[, 4]
survey[, "year"]
survey$year
survey[["year"]]
dim(survey[["year"]])

survey["year"]
dim(survey["year"])
str(survey["year"])



# exercices 

# Create a data.frame (surveys_200) 
# containing only the data in row 200 of the surveys dataset.
surveys_200 <- survey[200,]
surveys_200


# Notice how nrow() gave you the number of rows in a data.frame?
n_row <- nrow(survey)

# Use that number to pull out just that last row in the inital surveys data frame.
last_arrow <- survey[34786, ]
last_arrow

# Compare that with what you see as the last row using tail() to make sure it’s meeting expectations.
tail(survey)

# Pull out that last row using nrow() instead of the row number
# Create a new data frame (surveys_last) from that last row.
survey_last <- survey[n_row, ]
survey_last


# Use nrow() to extract the row that is in the middle of the surveys dataframe. 
# Store the content of this row in an object named surveys_middle.
nrow(survey)
survey_middle <- survey[17393,]
34786/2
survey_middle <- survey[nrow(survey)/2, ]
survey_middle

# Combine nrow() with the - notation above to reproduce the behavior of head(surveys), 
# keeping just the first through 6th rows of the surveys dataset.
head(survey)
survey[-(7:34786), ]
survey[-(7:nrow(survey)), ]



names(survey)
colnames(survey)
rownames(survey)



survey$weight
sel_w <- is.na(survey$weight)
length(sel_w) == nrow(survey)

# savoir quels weights sont manquants
table(sel_w)

# créer un nvx data frame qui correspond à ttes les obs qui avaient bien un poids
# le ! permet de dire qu'on prend ttes les observations qui possèdent bien un poids 
# "sel_w" nous permettait de déterminer les obs sans poids =>  on prend l'inverse de ça pour avoir les obs avec weight => !
survey_with_weight <- survey[!sel_w, ]
head(survey_with_weight)
dim(survey_with_weight)

# obs sans poids
nrow(survey[sel_w, ])
# obs avec poids
nrow(survey[!sel_w, ]) 


survey_noNA <- na.omit(survey)
dim(survey_noNA)

# import : 
read.csv()
read.csv()
read.delim()

# export
write.csv(survey_noNA, file = "data/survery_noNA.csv")

# save() and load()
# saveRDS() and readRDS()
saveRDS(survey_noNA, file = "data/survey_noNA.rds")
x <- readRDS("data/survey_noNA.rds")
dim(x)
class(x)






































