# retour cours 5
# colMeans() calcule toutes les moyennes par colonnes
# which.max(colMeans) = donne l'indice le plus élevé par colonne 


# cours 6
library(tidyverse)
survey_complete <- read_csv("./data/survey_noNA.csv") %>% 
  filter(!is.na(weight), 
         !is.na(hindfoot_length), 
         !is.na(sex))
survey

species_counts <- survey_complete %>% count(species_id) %>% 
  filter(n>=50)
survey_counts

survey_complete <- 
  survey_complete %>% 
  filter(species_id %in% species_counts$species_id)
survey_complete

write_csv(survey_complete, "data/survey_complete.csv")



# Data Visualization
library(ggplot2)
p <- ggplot(data=survey_complete,
       mapping = aes(x = weight,
                     y = hindfoot_length)) 

p + geom_point(alpha=0.1)

library(hexbin)
p+geom_hex()
p+ geom_point(alpha=0.1, 
              colour="blue")

p+geom_point(alpha = 0.5,
             aes(colour=species_id))

ggplot(data=survey_complete,
       mapping = aes(x = weight,
                     y = hindfoot_length, 
                     colour = species_id)) +geom_point( )


# Use what you just learned to create a scatter plot of weight over species_id with the plot types
# showing in different colors. Is this a good way to show this type of data?

co <- ggplot(data = survey_complete, 
             mapping = aes(x=species_id , 
                           y=weight, colour= plot_type)) + geom_point( )
co

ggplot(data = survey_complete, 
             mapping = aes(x=species_id , 
                           y=weight)) + geom_boxplot( ) +
  geom_jitter(alpha= 0.2)


ggplot(data = survey_complete, 
       mapping = aes(x=species_id , 
                     y=weight)) + geom_violin() + scale_y_log10()
  
yearly_count <-  survey_complete %>%
  count(year, species_id)

yearly_count %>% filter(species_id =="OL")

# obtenir une ligne par espèce en mappant la variable species_id pour séparer les données en sous-jeu de données en fonction des espèces
ggplot(yearly_count, 
       aes(x=year, 
           y= n, 
           group = species_id, 
           colour = species_id)) + geom_line()
# mnt, une ligne = une couleur = une espèce



# facetting 
ggplot(yearly_count, 
       aes(x=year, 
           y= n)) + geom_line() + facet_wrap(~ species_id)


# count the nb of species by year 
# and by sex 
yearly_sex_count <- survey_complete %>% count(year, sex, species_id)
yearly_sex_count  

p2 <- ggplot(yearly_sex_count, 
       aes(x = year,
           y= n, 
       colour = sex)) + geom_line( ) + facet_wrap(~species_id)



# composition de figures

p <- p + geom_point()

p2 
p3 <- p2 + p


# exporting figures
ggsave("figs/fig1.pdf")
ggsave("figs/fig1.png")
ggsave("figs/fig4.pdf", p2)











