# exercice 1 

library(tidyverse)
library(dplyr)

library(rWSBIM1207)
beers
View(beers)

data(beers)

# Remove observations with missing values.
beers2 <- beers[!is.na(beers)]
beers <- beers2
beers
is.na(beers)

# Using the Year, Month and Year columns, 
# create a new column Date using dplyr::mutate and lubridate::ymd. What is the class of Date ?
library(lubridate)

with_dplyr <- beers %>% select (Day, Month, Year) %>% 
  mutate(Date = c("Day","Month","Year"))
with_dplyr
# ????????????????????????????????????????????


# Create a new table, containing observations for women older than 35 years old, 
# employed, and select all columns except Day, Month and Year, and order in 
# descending value of consumption of beers.
new <- beers %>% filter(Gender == "Female", Age > "35", Work == "Employed") %>% 
  filter(!is.na(Consumption)) %>% select(-Day, -Month, -Year) %>% arrange(desc(Consumption))
new


# Export the new table to a csv file.
write.csv(new, file ="data/new.csv")


# Does employment status have an impact on beer consumption?
yes <- beers$Work == "Employed"
y <- beers[yes, "Consumption"]
moyy <- mean(y, na.rm = TRUE)
moyy

no <- beers$Work == "Unemployed"
nn <- beers[no, "Consumption"]
moyn <- mean(nn, na.rm= TRUE)

moyn>moyy


# Does employment status have an influence on beer consumption according to gender?
men_yes <- beers %>% filter(beers$Gender == "Male", beers$Work == "Employed",
                            (!is.na(Consumption))) %>% select(Consumption) %>%
                            summarize(moym_yes = mean(Consumption))
men_yes

men_no <- beers %>% filter(beers$Gender == "Male", beers$Work == "Unemployed",
                           (!is.na(Consumption))) %>% select(Consumption) %>%
                            summarize(moym_no = mean(Consumption))
men_no

women_yes <- beers %>% filter(beers$Gender== "Female", beers$Work== "Employed", 
                              (!is.na(Consumption))) %>% select(Consumption) %>% 
                              summarize(moyw_yes= mean(Consumption))
women_yes

women_no <- beers %>% filter(beers$Gender== "Female", beers$Work== "Unemployed", 
                             (!is.na(Consumption))) %>% select(Consumption) %>% 
                            summarize(moyw_no= mean(Consumption))
women_no


# Do men drink more than women?
men <- beers %>% filter(!is.na(Consumption), beers$Gender == "Male") %>%
  select(Gender, Consumption) %>% summarize(moy_men= mean(Consumption))
men
  
women <- beers %>% filter(!is.na(Consumption), beers$Gender == "Female") %>%
  select(Gender, Consumption) %>% summarize(moy_women= mean(Consumption))
women

men>women


# Do men drink more than women according to age and employment status?
men2y <- beers %>% filter(!is.na(Consumption), beers$Gender == "Male", 
                          beers$Work == "Employed") %>% select(Gender, Consumption, Age, Work) %>%
                          summarize(moy_men= mean(Consumption))
men2y

men2n <- beers %>% filter(!is.na(Consumption), beers$Gender == "Male", 
                          beers$Work == "Unemployed") %>% select(Gender, Consumption, Age, Work) %>% 
                          summarize(moy_men= mean(Consumption), count=n())
men2n

women2y <- beers %>% filter(!is.na(Consumption), beers$Gender == "Female", 
                            beers$Work == "Employed") %>% select(Work, Gender, Consumption, Age) %>% 
  group_by(Work, Consumption, Gender, Age) %>% summarize(moy_women= mean(Consumption))
women2y

women2n <- beers %>% filter(!is.na(Consumption), beers$Gender == "Female", 
                            beers$Work == "Unemployed") %>% select(Gender, Consumption, Age) %>% 
  summarize(moy_women= mean(Consumption))
women2n
# ??????????????????????????????????????????




# exercice2
# Using the clinical1.csv() function from rWSBIM1207,
# find the path the clinical1.csv file and read it to produce a data.frame named clinical.
clininal1 <- read_csv(clinical1.csv())
clinical <- clinical1


# Familiarise yourself with the data.
data(clinical1)


# Create a smaller data frame called clinical_mini containing only the columns corresponding 
# to patientID, gender, age_at_diagnosis, smoking_history, number_pack_years_smoked, 
# year_of_tobacco_smoking_onset, and stopped_smoking_year.

clinical_mini <- data.frame(clinical1$patientID, clinical1$gender, clinical1$age_at_diagnosis, 
                            clinical$smoking_history, clinical1$number_pack_years_smoked, 
                            clinical1$year_of_tobacco_smoking_onset, 
                            clinical1$stopped_smoking_year)
clinical_mini


# Calculate the number of males and females in the cohort.
table(clinical_mini$clinical1.gender)


# Create a new variable years_at_diagnosis corresponding 
# to the age at diagnosis converted from days into years.
years_at_diagnosis <- clinical1 %>% filter(!is.na(age_at_diagnosis)) %>% 
                                             mutate(years_at_diagnosis= age_at_diagnosis/365)
years_at_diagnosis


# Calculate the mean and median age at diagnosis (in years). Pay attention to missing values!
nona <- na.omit(clinical1)

moy <- mean(years_at_diagnosis$years_at_diagnosis, na.rm=TRUE)
moy

med<- median(years_at_diagnosis$years_at_diagnosis, na.rm=TRUE)
med


# Calculate the mean and median age at diagnosis for males and females.
m <- clinical1$gender == "male"
ma <- clinical1[m, "age_at_diagnosis"]
ma2 <- ma[!is.na(ma)]
moyma <- mean(ma2)
moyma

male <- clinical1 %>% filter(clinical1$gender = "male", (!is.na(age_at_diagnosis))) %>% 
  select(age_at_diagnosis) %>% group_by(age_at_diagnosis) %>% 
  summarize(moy= mean(age_at_diagnosis))
male


f <- clinical1$gender == "female"
fa <- clinical1[f, "age_at_diagnosis"]
fa2 <- fa[!is.na(fa)]
moyfa <- mean(fa2)
moyfa


# How many patient were diagnosed before 50 years? (answer = 32)
b4_50 <- years_at_diagnosis %>% filter(years_at_diagnosis < 50) 
b4_50


# Compare the mean age at diagnosis between current smoker and lifelong non-smoker 
# (in "smoking_history).

current <- clinical1 %>% filter(smoking_history == "current smoker")
current


lifelong <- clinical %>% filter(smoking_history == "lifelong non-smoker")
lifelong

c <- clinical1$smoking_history == "current smoker"
cm <- clinical1[c, "age_at_diagnosis"]
cm2 <- cm[!is.na(cm)]
moyc <- mean(cm2)
moyc

l <- clinical1$smoking_history == "lifelong non-smoker"
lm <- clinical1[l, "age_at_diagnosis"]
lm2 <- lm[!is.na(lm)]
moyl <- mean(lm2)
moyl

moyc < moyl


# Select patients who stopped smoking more than 15 years ago 
# and calculate the number of smoking years for these cases.
# Display only cases for which you were able to calculate the data.
b4_15 <- clinical1 %>% filter(year_of_tobacco_smoking_onset < 2021-15)
b4_15
minus <- clinical1$year_of_tobacco_smoking_onset
minus2 <- clinical1$stopped_smoking_year
minuss <- minus2-minus
minusss <- minuss[!is.na(minuss)]

nb_b415 <- clinical1 %>% filter(!is.na(year_of_tobacco_smoking_onset)) %>% 
  filter(!is.na(stopped_smoking_year)) %>% filter(stopped_smoking_year < 2021-15) %>%
  group_by(year_of_tobacco_smoking_onset, stopped_smoking_year) %>%
  summarize(count=n())%>% print(n=200) 
nb_b415

nb_smo <- nb_b415 %>% mutate(calc= stopped_smoking_year - year_of_tobacco_smoking_onset)
nb_smo


# How many of them smoked less than 5 years? (answer=4)
nb_smo5 <- nb_smo %>% filter(calc<5)
nb_smo5


# Try to recreate the following table, reporting the number of smokers and 
# lifelong-non smoker between males and females. Note: the layout can be different.
gender <- c("female", "male")
current_smoker <- c(51, 69)
lifelong_nonsmoker <- c(55, 20)

dfr <- data.frame(gender= gender, current_smoker = current_smoker, 
                  lifelong_nonsmoker = lifelong_nonsmoker)
dfr

longer <- pivot_longer(dfr, cols= c(current_smoker, lifelong_nonsmoker, -gender), 
                       names_to = "smoking_situation", 
                       values_to = "analysis")
longer





# exercice 3
# Using the interroA.csv() function from the rWSBIM1207 package to get the path to the
# spreadsheet file, read the data into R using the read_csv function. This data is in
# the wide format, with the results of each test stored as a separate column.
library(tidyverse)
interroA <- read_csv(interroA.csv())
interroA


# Using the appropriate pivot function, convert the data into a long table with a 
# column interro informing which test that line refers to and a column result with
# the student’s mark.
longer <- pivot_longer(interroA, cols = c(interro1, interro2, interro3, interro4), 
                       names_to= "interro" ,  values_to = "result") %>% print(n=400)
longer 

