library(rWSBIM1207)
library(tidyverse)
data(jdf)

# exercice 1

# Using the jdf4 and jdf5 tables, emulate the left, 
# right and inner joins using a the full join and filter functions.

# 1 left
lef <- left_join(jdf4, jdf5)

l <- full_join(jdf4, jdf5)
left <- l %>% filter(!is.na(organelle), !is.na(entry))
left

lef == left


# 2 right
ri <- right_join(jdf4, jdf5)
ri

r <- full_join(jdf4, jdf5)
right <- r %>% filter(!is.na(gene_name), !is.na(description), !is.na(organism))
right


# inner 

inn <- inner_join(jdf4, jdf5)
inn

i <- full_join(jdf4, jdf5)
inner <- i %>% filter(!is.na(organelle), !is.na(entry), 
                      !is.na(gene_name), !is.na(description), !is.na(organism))
inner

inn == inner





# exercice 2

data("clinical2")
data("expression")


# Inspect the clinical data. 
# What kind of information do we have and how many patients are recorded?
names(clinical2)
dim(clinical2)


# Inspect the expression data. How many samples are recorded?
names(expression)
dim(expression)


# Join the expression and clinical2 tables by the patient reference, 
# using the left_join and the right_join functions. Why are the results different?
left <- left_join(clinical2, expression, by = c("patientID" = "patient"))
left

right <- right_join(clinical2, expression, by = c("patientID" = "patient"))
right

dim(left)
dim(right)
# why are the results different???? 


# Join expression and clinical2 tables in order to create a table containing 
# merged data exclusively for normal samples.

m <- merge(clinical2, expression, all.clinical2 = TRUE, all.expression = TRUE)

norm <- m %>% filter(type == "normal")
norm

















