library(ggplot2)
library(tidyverse)

library(rWSBIM1207)
data("beers")
beers

# Analyse the data to answer the question Do men drink more than women according to age and working status? 
# Now reproduce the figure below.

men_em <- beers %>% filter(!is.na(Consumption), Gender == "Male", Work == "Employed") %>% 
  group_by(Age) %>% 
  summarize(moy= mean(Consumption), count=n()) %>%
  arrange(desc(Age))
men_em

men_unem <- beers %>% filter(!is.na(Consumption), Gender == "Male", Work == "Unemployed") %>% 
  group_by(Age) %>% 
  summarize(moy= mean(Consumption), count=n()) %>%
  arrange(desc(Age))
men_unem

library(patchwork)
men_emm <- ggplot(men_em, aes(x= Age, y = Consumption)) + geom_line() + geom_point()
men_umm <- ggplot(men_unem, aes(x= Age, y = Consumption)) + geom_line()

men <- men_emm + men_umm






women_em <- beers %>% filter(!is.na(Consumption), Gender == "Female", Work == "Employed") %>% 
  group_by(Age) %>% 
  summarize(moy= mean(Consumption), count=n()) %>%
  arrange(desc(Age))
women_em

women_unem <- beers %>% filter(!is.na(Consumption), Gender == "Female", Work == "Unemployed") %>% 
  group_by(Age) %>% 
  summarize(moy= mean(Consumption), count=n()) %>%
  arrange(desc(Age))
women_unem




library(rWSBIM1207)

# exercice 2
expression <- read_csv(expression.csv())
data("expression")
expression

# Using geom_point, draw a plot showing distribution of expression levels of A2LD1 
# in normal tissue samples and in primary tumor samples.
count <- expression %>% count(sampleID, type, A2LD1) %>% print(n=700)
count

n_t <- ggplot(count, aes(x=A2LD1, y=type)) + geom_point(alpha=0.5)
n_t


# Repeat this visualisation using this time the geom_jitter. 
# Which representation is more appropriate? Why? => plus appropriée car on voit mieux la valeur des points
n_t2 <- ggplot(count, aes(x=type, y=A2LD1)) + geom_jitter(alpha=0.5)
n_t2


# Colour the samples according to the tissue type.
n_t3 <- ggplot(count, aes(x=sampleID, y=A2LD1, colour=type)) + geom_jitter(alpha=0.5)
n_t3


# Colour the samples according to their expression level in A2ML1.
count2 <- expression %>% count(A2ML1, type, sampleID)
n_t4 <- ggplot(count2, aes(x=sampleID, y=A2ML1, colour=type)) + geom_point(alpha=0.5)
n_t4


# Highlight the points corresponding to patient “TCGA-73-4676.”
count_3 <- pivot_longer(expression, cols= c(A2ML1, A2LD1, A2BP1, A1CF, A1BG), 
                        names_to = "Genus", values_to= "Exp")
count_3

count3 <- count_3 %>% filter(patient== "TCGA-73-4676")

n_t5 <- ggplot(count3, aes(x=Genus, y=type)) +
  geom_jitter(alpha=0.5)
n_t5


# Add a transparent boxplot to the graph.
n_t5 <- ggplot(count3, aes(x= type, y=Genus)) +
  geom_jitter(alpha=0.5) + geom_boxplot()
n_t5


# 






# exercice 3

# After gathering the interroA data from the rWSBIM1207 package in a long table format, 
# visualise the results for each test and male/female students.

interroA <- read_csv(interroA.csv())

longer <- pivot_longer(interroA, cols= c(interro1, interro2, interro3, interro4), 
                       names_to = "interros", values_to = "results")
longer

nb <- longer %>% count(gender, interros, results) %>% filter(!is.na(results))

nbb <- ggplot(nb, aes(x=gender, y=results , colour=interros)) + geom_jitter(alpha=0.5)
nbb







