
library(dplyr)
library(tidyverse)

survey <- read_csv("data/survey_noNA.csv")
survey

# Using pipes, subset the surveys data to include animals collected 
# before 1995 and retain only the columns year, sex, and weight.
b4_1995 <- survey %>% filter(year < "1995") %>% select(year, sex, weight)
b4_1995


# Create a new data frame from the surveys data that meets the following criteria: 
# contains only the species_id column and a new column called hindfoot_half containing 
# values that are half the hindfoot_length values. In this hindfoot_half column, 
# there are no NAs and all values are less than 30.

hd_half <- survey %>% filter(!is.na(hindfoot_length))%>% 
   mutate(hindfoot_half = hindfoot_length/2) %>% 
  filter(!is.na(hindfoot_half), hindfoot_half < "30") %>% select(species_id, hindfoot_half)
hd_half


# How many animals were caught in each plot_type surveyed?
animals <- survey %>% group_by(plot_type) %>% summarize(count = n())
animals

# Use group_by() and summarize() to find the mean, min, and max hindfoot length for each species 
# (using species_id). Also add the number of observations (hint: see ?n).

calc <- survey %>% group_by(species_id) %>% 
  summarize(moy=mean(hindfoot_length, na.rm =TRUE), 
            max=max(hindfoot_length, na.rm = TRUE), 
            min=min(hindfoot_length, na.rm=TRUE), 
            count = n())
calc

# What was the heaviest animal measured in each year? 
# Return the columns year, genus, species_id, and weight

w8 <- survey %>%
  filter(!is.na(weight)) %>%
  group_by(year) %>%
  filter(weight == max(weight)) %>%
  select(year, genus, species, weight) %>%
  arrange(year)
w8


# 






